#include "TeX.h"

#define printf(c) debug(c);
void drawMathExp(char *exp, uint level, int x, int y, int l);
void getExpSize(char *exp, uint level, int *pw, int *ph, int *pl);

extern unsigned char *Txt_VRAM;
#define setPixel(x,y,v) setPixel(x,y,v,Txt_VRAM)
char ch[200];

void getSizeOf(char *exp, uint level, int *pw, int *ph, int *pl)
{
  int w=6*strlen(exp)-1, h=7, l=3;
  int tw, th, tl=1;
  char *args[3];
  char *p,*q, *tmp;
  int param, c, i;

  if(!*exp) { *pw=0; *ph=0; if(pl) *pl=0; return; }

  for(i=0;i<(level>0xFF000000?level-0xFF000000:level);i++) printf("\t");
  printf("getSizeOf() called for simple expression \"");
  printf(exp);
  printf("\".\015\012");

  if(level>0xFF000000) {
    level-=0xFF000000;
    for(i=0;i<level;i++) printf("\t");
    printf("At top level, expression is text.\015\012");
    *pw=w, *ph=h; if(pl) *pl=l; return; }

  if(level>=10 || *exp!='\\') {
    for(i=0;i<level;i++) printf("\t");
    printf("Expression is text.\015\012");
    *pw=w, *ph=h; if(pl) *pl=l; return; }

  p = strchr(exp,'{');
  if(p==NULL) { *pw=w; *ph=h; if(pl) *pl=l; return; }
  exp++;

  if(!strncmp(exp,"frac",p-exp))
  {
    h=3;
    w=0;
    for(param=0;param<2;param++)
    {
      c=0, tmp=p;
      while(*tmp) {
        if(*tmp=='{') c++;
        if(*tmp=='}') c--;
        if(*tmp=='}' && !c) break;
        tmp++; }
 
      q = tmp;
 
      args[param] = (char *)calloc(q-p,1);
      strncpy(args[param],p+1,q-p-1);
      p=q+1;

      getExpSize(args[param],level+1,&tw,&th,&tl);
      h += th;
      if(tw>w) w=tw;
      if(!param) l = th;
    }
    w+=2;
  }

  if(!strncmp(exp,"vec",p-exp))
  {
    w=0, h=11, l=3;

    for(q=p;*q-'}';q++);
    args[0] = (char *)calloc(q-p,1);
    strncpy(args[0],p+1,q-p-1);

    getSizeOf(args[0],level+1+0xFF000000,&tw,&th,&tl);
    w=tw, h=th+4, l=tl+3;
  }

  if(!strncmp(exp,"sqrt",p-exp))
  {
    w=0, h=0, l=0;
    c=0, tmp=p;

    while(*tmp) {
      if(*tmp=='{') c++;
      if(*tmp=='}') c--;
      if(*tmp=='}' && !c) break;
      tmp++; }
    q = tmp;

    args[0] = (char *)calloc(q-p,1);
    strncpy(args[0],p+1,q-p-1);

    getExpSize(args[0],level+1,&tw,&th,&tl);
    l = tl+1;
    w = tw+6;
    h = th+3;
  }

  if(!strncmp(exp,"sum",p-exp))
  {
    h=11, w=0;

    for(param=0;param<2;param++)
    {
      c=0, tmp=p;
      while(*tmp) {
        if(*tmp=='{') c++;
        if(*tmp=='}') c--;
        if(*tmp=='}' && !c) break;
        tmp++; }
 
      q = tmp;
 
      args[param] = (char *)calloc(q-p,1);
      strncpy(args[param],p+1,q-p-1);
      p=q+1;

      getExpSize(args[param],level+1,&tw,&th,&tl);
      h += th;
      if(tw>w) w=tw;
      if(!param) l = th;
    }
    w+=2;
  }

  *pw = w, *ph = h;
  if(pl) *pl = l+1;
}

void getExpSize(char *exp, uint level, int *pw, int *ph, int *pl)
{
  int width=0, height=0, baseline=0;
  char *p=exp, *q=NULL, *tmp=NULL;
  char formula[200];
  int c, param;
  int tw, th, tl;

  int i;
  for(i=0;i<level;i++) printf("\t");
  printf("getExpSize() called for expression \"");
  printf(exp);
  printf("\".\015\012");

  while(1)
  {
    if(*p!='\\')
    {
      q=strchr(p,'\\');
      if(!q) { q=p; while(*q) q++; }
    }
    else
    {
      tmp = strchr(p+1,'{');
      if(!strncmp(p+1,"frac",tmp-p-1)) param=2;
      else if(!strncmp(p+1,"vec",tmp-p-1)) param=1;
      else if(!strncmp(p+1,"sqrt",tmp-p-1)) param=1;
      else if(!strncmp(p+1,"sum",tmp-p-1)) param=2;

      c=0, tmp=p+1;
      while(*tmp) {
        if(*tmp=='{') c++;
        if(*tmp=='}') c--;
        if(*tmp=='}' && !c) param--;
        tmp++;
        if(!param) break; }
      q = tmp;
    }

    if(!(q-p)) { *pw=width; *ph=height; if(pl) *pl=baseline; return; }

    formula[q-p]=0;
    strncpy(formula,p,q-p);

    if(q-p==strlen(p))
    {
      getSizeOf(formula,level+1,&tw,&th,&tl);
    }
    else
    {
      width++;
      getSizeOf(formula,level+1,&tw,&th,&tl);
    }

    width += tw;
    if(th>height) height=th;
    if(tl>baseline) baseline=tl;

    p = q;
    if(!*(p+1)) break;
  }

  for(i=0;i<level;i++) printf("\t");
  printf("Size of \"");
  printf(exp);
  sprintf(ch,"\" found. Width:%d Height:%d baseLine:%d\015\012",width,height,baseline);
  printf(ch);

  *pw = width;
  *ph = height;
  if(pl) *pl = baseline;
}

void drawMathFormula(char *exp, uint level, int x, int y, int l)
{
  int w,h, tw[3]={0},th[3]={0},tl[3]={0};
  int param, c, j;
  char *args[3];
  char *p,*q, *tmp;

  getSizeOf(exp,0,&w,&h,NULL);

  if(level>=10 || *exp!='\\')
  {
    Txt_Text((const char *)exp,x,y+l-3,TXT_SYSTEM,TXT_XOR);
    return;
  }

  p=strchr(exp,'{');
  if(p==NULL) return;
  exp++;

  if(!strncmp(exp,"frac",p-exp))
  {
    h=3;
    w=0;
    for(param=0;param<2;param++)
    {

      c=0, tmp=p;
      while(*tmp) {
        if(*tmp=='{') c++;
        if(*tmp=='}') c--;
        if(*tmp=='}' && !c) break;
        tmp++; }
 
      q = tmp;
 
      args[param] = (char *)calloc(q-p,1);
      strncpy(args[param],p+1,q-p-1);
      p=q+1;

      getExpSize(args[param],level+1,tw+param,th+param,tl+param);
      tl[param] = l+(param?1:-1)*(tl[param]+2);
      if(tw[param]>w) w = tw[param];
    }

    w += 2;

    for(param=0;param<2;param++)
      drawMathExp(args[param],level+1,x+(w-tw[param])/2,y,tl[param]);

    for(j=0;j<w;j++) setPixel(x+j,y+l,1);
  }

  if(!strncmp(exp,"vec",p-exp))
  {
    w=0, h=11;

    for(q=p;*q-'}';q++);
    args[0] = (char *)calloc(q-p,1);
    strncpy(args[0],p+1,q-p-1);
    getSizeOf(args[0],level+1+0xFF000000,&w,th,tl);

    Txt_Text((const char *)args[0],x,y+l-3,TXT_SYSTEM,TXT_XOR);
    for(j=0;j<w;j++) setPixel(x+j,y+l-6,1);
    setPixel(x+w-2,y+l-5,1);
    setPixel(x+w-2,y+l-7,1);
  }

  if(!strncmp(exp,"sqrt",p-exp))
  {
    w=0, h=0;
    c=0, tmp=p;

    while(*tmp) {
      if(*tmp=='{') c++;
      if(*tmp=='}') c--;
      if(*tmp=='}' && !c) break;
      tmp++; }
    q = tmp;

    args[0] = (char *)calloc(q-p,1);
    strncpy(args[0],p+1,q-p-1);

    getExpSize(args[0],level+1,tw,th,tl);
    w = *tw+6, h = *th+3;

    drawMathExp(args[0],level+1,x+4,y,l);
    for(j=0;j<h;j++) setPixel(x+2,y+l-*tl+j-2,1);
    setPixel(x+1,y+l-*tl+h-4,1);
    setPixel(x,y+l-*tl+h-5,1);
    for(j=0;j<w-2;j++) setPixel(x+2+j,y+l-*tl-2,1);
    for(j=0;j<2;j++) setPixel(x+w-1,y+l-*tl-1+j,1);
  }

  if(!strncmp(exp,"sum",p-exp))
  {
    int n;
    h=11, w=0;

    for(param=0;param<2;param++)
    {
      c=0, tmp=p;
      while(*tmp) {
        if(*tmp=='{') c++;
        if(*tmp=='}') c--;
        if(*tmp=='}' && !c) break;
        tmp++; }
 
      q = tmp;
 
      args[param] = (char *)calloc(q-p,1);
      strncpy(args[param],p+1,q-p-1);
      p=q+1;

      getExpSize(args[param],level+1,tw+param,th+param,tl+param);
      tl[param] = l+(param?-1:1)*(tl[param]+6);
      if(tw[param]>w) w = tw[param];
    }

    w += 2;

    for(param=0;param<2;param++)
      drawMathExp(args[param],level+1,x+(w-tw[param])/2,y,tl[param]);

    n = (w-8)>>1;
    for(j=0;j<8;j++) setPixel(x+n+j,y+l-4,1), setPixel(x+n+j,y+l+4,1);
    for(j=0;j<3;j++) setPixel(x+n+j+1,y+l-3+j,1), setPixel(x+n+j+1,y+l+3-j,1);
    setPixel(x+n+4,y+l,1);
    setPixel(x+n+7,y+l-3,1);
    setPixel(x+n+7,y+l+3,1);
  }
}

void drawMathExp(char *exp, uint level, int x, int y, int l)
{
  int xi=x, yi=y;
  char *p=exp, *q=NULL, *tmp=NULL;
  char formula[200];
  int c, param;
  int tw, th;

  while(1)
  {
    if(*p!='\\')
    {
      q=strchr(p,'\\');
      if(!q) { q=p; while(*q) q++; }
    }
    else
    {
      tmp = strchr(p+1,'{');
      if(!strncmp(p+1,"frac",tmp-p-1)) param=2;
      else if(!strncmp(p+1,"vec",tmp-p-1)) param=1;
      else if(!strncmp(p+1,"sqrt",tmp-p-1)) param=1;
      else if(!strncmp(p+1,"sum",tmp-p-1)) param=2;

      c=0, tmp=p+1;
      while(*tmp && param) {
        if(*tmp=='{') c++;
        if(*tmp=='}') c--;
        if(*tmp=='}' && !c) param--;
        tmp++; }
      q = tmp;
    }

    if(!(q-p)) return;
    formula[q-p]=0;
    strncpy(formula,p,q-p);

    if(q-p==strlen(p)) getSizeOf(formula,level+1,&tw,&th,NULL);
    else getExpSize(formula,level+1,&tw,&th,NULL);

    drawMathFormula(formula,level+1,xi,yi,l);
    xi += tw;
    if(q-p!=strlen(p)) xi++;

    p = q;
    if(!*(p+1)) break;
  }
}

